subroutine CalcEnergy(Pos, L, rc, eps, g, PEnergy, Dim, NAtom)
    implicit none
    integer, intent(in) :: Dim, NAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in) :: L, rc, eps, g
    real(8), intent(out) :: PEnergy
    real(8), parameter :: r0 = 1. 
    !======== YOUR CODE HERE ========
    real(8), dimension(Dim) :: rij, Posi
    real(8) :: d2, rc2, r02
    integer::i,j
    rc2 = rc * rc
    PEnergy = 0.
    r02 = r0**2
  
    do i = 0 , NAtom - 1
        Posi = Pos(i,:)
      ! Gravitational field
         PEnergy = PEnergy + g*(Posi(3))
        if (Posi(3) < rc .and. Posi(3) > r0) then
    ! particle - surface interactions
           PEnergy = PEnergy - 0.1*eps
        else
           if (Posi(3) < r0) then
               PEnergy = PEnergy + 1.*10.**18
           endif
           if (Posi(3) > rc) then
               PEnergy = PEnergy + 0
           endif
        endif
        do j = i + 1 , NAtom - 1
    ! Particle-Particle Interactions  
            rij=Pos(j,:)-Posi
            rij=rij - L * dnint(rij / L)
            d2 = sum(rij * rij)
            if (d2 < rc2 .and. d2 > r02) then
                PEnergy = PEnergy - eps
            else
                if (d2 < r02) then
                    PEnergy = PEnergy + 1.*10.**18
                endif
                if (d2 > rc2) then
                    cycle
                endif
            endif
        enddo
    enddo
    
    

end subroutine

    
subroutine SingleEnergy(Pos,atom, L, rc, eps, g, PEnergy, Dim, NAtom)
    implicit none
    integer, intent(in) :: Dim, NAtom, atom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in) :: L, rc, eps, g
    real(8), intent(out) :: PEnergy
    real(8), parameter :: r0 = 1.
    !======== YOUR CODE HERE ========
    real(8), dimension(Dim) :: rij, Posi
    real(8) :: d2,rc2, r02
    integer::j
    rc2 = rc * rc
    r02 = r0**2
    PEnergy = 0.
    
    posi = Pos(atom,:)
    
       ! Gravitational field
    PEnergy = PEnergy + g*(Posi(3))
    if (Posi(3) < rc .and. Posi(3) > r0) then
   !  particle - surface interactions
        PEnergy = PEnergy - 0.1*eps
        else
        if (Posi(3) < r0) then
           PEnergy = PEnergy + 1.*10.**18
        endif
        if (Posi(3) > r0) then
                PEnergy = PEnergy + 0
        endif
    endif

    do j = 0 , NAtom - 1
        if (atom == j) then
            cycle
        endif
        rij=Pos(j,:)-Posi
        rij=rij - L * dnint(rij / L)
        d2 = sum(rij * rij)
        !Particle-particle!
        if (d2 < rc2 .and. d2 > r02) then
            PEnergy = PEnergy - eps
        else
            if (d2 < r02) then
                PEnergy = PEnergy + 1.*10.**18
            endif
            if (d2 > rc2) then
                cycle
            endif 
        endif
    enddo
end subroutine


subroutine Distances(Pos, L, Dist, Dim, NAtom)
    implicit none
    integer, intent(in) :: Dim, NAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in) :: L
    real(8), intent(out), dimension(0:NAtom-1, 0:NAtom-1) :: Dist
    real(8), dimension(Dim) :: rij, Posi
    real(8) :: d2
    integer::j,i
    
do i = 0, NAtom-1
    posi = Pos(i,:)   
    if (posi(3) < 1.3) then
    do j = 0 , NAtom - 1        
        rij=Pos(j,:)-Posi
        rij=rij - L * dnint(rij / L)
        d2 = sum(rij * rij)
        Dist(i,j) = d2**(1./2.)
    end do
    else
        cycle
    endif
enddo
end subroutine





